



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>offsetleft、offsetTop、offsetParent的兼容性问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">offsetleft、offsetTop、offsetParent的兼容性问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 20:54:23 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div><strong>先来看看offsetParent返回的是什么值</strong></div>
<div>ele.offsetParent返回的是ele元素最近的并且是定位过(relative,absolute)的父元素，如果没有父元素或者是父元素中没有一个是定位过的，返回值就是body元素</div>
<div>&nbsp;</div>
<div><strong>ele.offsetLeft和ele.offsetTop取值问题，分多种情况：</strong></div>
<div>如果ele是body的直接子元素，返回值则是ele距离body左侧或顶部的距离</div>
<div>如果ele不是body的直接子元素，在父元素进行定位(relative,absolute)的情况下，各浏览器返回值都是ele距离父元素左侧或者是顶部的距离（唯一的区别就是chrome没有把边框计算进去，IE,firefox都计算进去了）</div>
<div>如果ele不是body的直接子元素，父元素也没有进行定位的情况下，各浏览器返回的直接是ele元素距body的距离</div>
<div>&nbsp;</div>
<div>从上面可以看出offsetLeft、offsetTop返回的值就是ele到offsetParent的距离，这个offsetParent是什么元素要看ele的父元素有没有进行定位（relative、absolute）</div>
<div>&nbsp;</div>
<div><strong>应用：</strong></div>
<div>在要获取元素距离网页左侧距离的时候就要考虑offsetParent的定位问题，不能简单的用ele.offsetLeft/Top获取，必须通过循环累加的方式才能获得正确值（chrome的结果和IE、Firefox不一样，相差1px，原因是chrome没有把边框计算进去），下面是代码</div>
<div>
<div>
<pre class="prettyprint linenums">var getOffset = {<br />
	left:function(obj){<br />
		return obj.offsetLeft + (obj.offsetParent ? this.left(obj.offsetParent) : 0);<br />
	},<br />
	top:function(){<br />
		return obj.offsetTop + (obj.offsetParent ? this.top(obj.offsetParent) : 0);<br />
	}<br />
};
</pre>
</div>
<p>Tips：代码中的this.left、this.top可以用arguments.callee代替，但根据ECMAScript 5规范不建议使用，strict model下已经被禁用，因为arguments是一个比较庞大的对象，非常耗资源</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390m6m8d.html">Android消息传递之基于RxJava实现一个EventBus - RxBus</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kmwd79.html">&ast;HDU1053 哈夫曼编码</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7gzrgq.html">用js编程输出100以内所有的质数和个数（提示：一个大于1的自然数，除了1和它本身外，不能被其他自然数整除的数都是质数）</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvpjpxq.html">Linux学习笔记&lpar;22&rpar; Linux启动管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyev6g9.html">netbeans使用技巧总结&plus;快捷键大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xykoz9.html">OVS ARP Responder &ndash; Theory and Practice</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnzonpq.html">hibernate简单应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm66le9.html">DFS的基础训练清单</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdmmxy8.html">使用ef code first模式，在部署后服务器端把数据库同步到最新版本的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wzpv3q.html">洛谷 P1515 旅行</a>
		</li>
						<li><a href="https://www.batexi.com/a/96poj148.html">【每日一摩斯】-Troubleshooting&colon; High CPU Utilization &lpar;164768&period;1&rpar; - 系列5</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1keml69.html">JS正则四个反斜杠的含义</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj7pk39.html">&lpar;C&sol;C&plus;&plus;学习笔记&rpar; 二十二&period; 标准模板库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve1kgo9.html">迷宫问题的C语言求解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlvwnl9.html">&lpar;org&period;jbehave&period;core&period;failures&period;BeforeOrAfterFailed&colon; webdriver selenium错误解决。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvxyz2q.html">MemSQL Start&lbrack;c&rsqb;UP 2&period;0 - Round 1 E - Three strings  广义后缀自动机</a>
		</li>
						<li><a href="https://www.batexi.com/a/902lo7oq.html">第十一章 企业项目开发--消息队列activemq</a>
		</li>
						<li><a href="https://www.batexi.com/a/9020dz4q.html">使用平台调用（P&sol;Invoke）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp6vzy9.html">NSArray打印汉字的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vo752q.html">Tomcat服务器的搭建</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/0qwzre3q.html">学会使用简单的 MySQL 常用操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pv7ly9.html">C&num; 中 SQLite 使用介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o23z59.html">地产cio揭秘：帆软大商业智能解决方案如何助力地产行业信息化</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx44ev9.html">【HTML5】使用多媒体</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rwwo7q.html">三维网格去噪算法（two-step framework）</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zlxd1q.html">jQuery学习笔记（一）：入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/495nv2m9.html">eclipse的包的加减号展开方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/39010wm8.html">RFID基础知识</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pv5k49.html">jquery插件集</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pv5x49.html">grunt-contrib-uglify压缩插件的常用配置属性</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
